
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SimulationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const simulations = await db.simulations.create(
            {
                id: data.id || undefined,
        
        simulation_title: data.simulation_title
        ||
        null
            ,
            
        simulation_type: data.simulation_type
        ||
        null
            ,
            
        scenario_context: data.scenario_context
        ||
        null
            ,
            
        success_criteria: data.success_criteria
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await simulations.setMission( data.mission || null, {
            transaction,
        });
        
        await simulations.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return simulations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const simulationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                simulation_title: item.simulation_title
            ||
            null
            ,
            
                simulation_type: item.simulation_type
            ||
            null
            ,
            
                scenario_context: item.scenario_context
            ||
            null
            ,
            
                success_criteria: item.success_criteria
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const simulations = await db.simulations.bulkCreate(simulationsData, { transaction });

        // For each item created, replace relation files
        

        return simulations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const simulations = await db.simulations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.simulation_title !== undefined) updatePayload.simulation_title = data.simulation_title;
        
        
        if (data.simulation_type !== undefined) updatePayload.simulation_type = data.simulation_type;
        
        
        if (data.scenario_context !== undefined) updatePayload.scenario_context = data.scenario_context;
        
        
        if (data.success_criteria !== undefined) updatePayload.success_criteria = data.success_criteria;
        
        
        updatePayload.updatedById = currentUser.id;

        await simulations.update(updatePayload, {transaction});

        
        
        if (data.mission !== undefined) {
            await simulations.setMission(
              
              data.mission,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await simulations.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return simulations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const simulations = await db.simulations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of simulations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of simulations) {
                await record.destroy({transaction});
            }
        });


        return simulations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const simulations = await db.simulations.findByPk(id, options);

        await simulations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await simulations.destroy({
            transaction
        });

        return simulations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const simulations = await db.simulations.findOne(
            { where },
            { transaction },
        );

        if (!simulations) {
            return simulations;
        }

        const output = simulations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.simulation_steps_simulation = await simulations.getSimulation_steps_simulation({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.mission = await simulations.getMission({
            transaction
        });
        
        
        output.organizations = await simulations.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.missions,
        as: 'mission',
        
        where: filter.mission ? {
          [Op.or]: [
            { id: { [Op.in]: filter.mission.split('|').map(term => Utils.uuid(term)) } },
            {
              mission_title: {
                [Op.or]: filter.mission.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.simulation_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'simulations',
                        'simulation_title',
                        filter.simulation_title,
                    ),
                };
            }
            
            if (filter.scenario_context) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'simulations',
                        'scenario_context',
                        filter.scenario_context,
                    ),
                };
            }
            
            if (filter.success_criteria) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'simulations',
                        'success_criteria',
                        filter.success_criteria,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.simulation_type) {
                where = {
                    ...where,
                simulation_type: filter.simulation_type,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.simulations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'simulations',
                        'simulation_title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.simulations.findAll({
            attributes: [ 'id', 'simulation_title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['simulation_title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.simulation_title,
        }));
    }

    
};

